package com.chenyang.druid.sql.dialect.mariadb.ast.statement;

import com.chenyang.druid.sql.ast.SQLExpr;
import com.chenyang.druid.sql.ast.SQLSubPartitionBy;
import com.chenyang.druid.sql.ast.statement.SQLColumnDefinition;
import com.chenyang.druid.sql.dialect.mariadb.ast.MariadbObject;
import com.chenyang.druid.sql.dialect.mariadb.visitor.MariadbASTVisitor;
import com.chenyang.druid.sql.visitor.SQLASTVisitor;
import java.util.ArrayList;
import java.util.List;

public class MariadbSubPartitionByList extends SQLSubPartitionBy implements MariadbObject {
   private List<SQLExpr> keys = new ArrayList();
   private List<SQLColumnDefinition> columns = new ArrayList();

   protected void accept0(SQLASTVisitor visitor) {
      if (visitor instanceof MariadbASTVisitor) {
         this.accept0((MariadbASTVisitor)visitor);
      } else {
         throw new IllegalArgumentException("not support visitor type : " + visitor.getClass().getName());
      }
   }

   public void accept0(MariadbASTVisitor visitor) {
      if (visitor.visit(this)) {
         this.acceptChild(visitor, this.keys);
         this.acceptChild(visitor, this.columns);
         this.acceptChild(visitor, this.subPartitionsCount);
      }

      visitor.endVisit(this);
   }

   public List<SQLExpr> getKeys() {
      return this.keys;
   }

   public void addKey(SQLExpr key) {
      if (key != null) {
         key.setParent(this);
      }

      this.keys.add(key);
   }

   public List<SQLColumnDefinition> getColumns() {
      return this.columns;
   }

   public void addColumn(SQLColumnDefinition column) {
      if (column != null) {
         column.setParent(this);
      }

      this.columns.add(column);
   }

   public void cloneTo(MariadbSubPartitionByList x) {
      super.cloneTo(x);

      for(SQLExpr key : this.keys) {
         SQLExpr k2 = key.clone();
         k2.setParent(x);
         x.keys.add(k2);
      }

      for(SQLColumnDefinition column : this.columns) {
         SQLColumnDefinition c2 = column.clone();
         c2.setParent(x);
         x.columns.add(c2);
      }

   }

   public MariadbSubPartitionByList clone() {
      MariadbSubPartitionByList x = new MariadbSubPartitionByList();
      this.cloneTo(x);
      return x;
   }
}
